//+------------------------------------------------------------------+
//|                                                omacd 4 color mtf |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DodgerBlue
#property indicator_color2  Red
#property indicator_color3  ForestGreen
#property indicator_color4  DeepPink
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int    FastMaPeriod     = 12;
extern int    FastMaMode       = 1;
extern int    FastMaPrice      = 0;
extern int    SlowMaPeriod     = 26;
extern int    SlowMaMode       = 1;
extern int    SlowMaPrice      = 0;
extern int    SignalMaPeriod   = 9;
extern int    SignalMaMode     = 1;
extern int    Histo_Size       = 3;//1=Standard Lines & Histo
extern bool   Show_MACDLine    = false; 
extern bool   Show_MACDSigLine = false;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern string soundfile        = "alert2.wav";

//
//
//
//
//

double osma[];
double up1[];
double dn1[];
double macd[];
double sign[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
 IndicatorBuffers(6);
   SetIndexBuffer(0,up1);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dn1);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macd);  
   SetIndexBuffer(3,sign);   
   SetIndexBuffer(4,osma);
   SetIndexBuffer(5,trend);
   if (Show_MACDLine)
   {
     SetIndexStyle(2,DRAW_LINE); 
   }
   else
   {
     SetIndexStyle(2,DRAW_NONE);
   } 
   if (Show_MACDSigLine)
   {
     SetIndexStyle(3,DRAW_LINE); 
   }
   else
   {
     SetIndexStyle(3,DRAW_NONE);
   }             
   
     FastMaPeriod   = MathMax(FastMaPeriod,1);
     SlowMaPeriod   = MathMax(SlowMaPeriod,1);
     SignalMaPeriod = MathMax(SignalMaPeriod,1); 
   IndicatorShortName("ColoredMACD ("+FastMaPeriod+","+SlowMaPeriod+")");
return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


int start()
  {
   
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) macd[i] = iMA(NULL,0,FastMaPeriod,0,FastMaMode,FastMaPrice,i)-iMA(NULL,0,SlowMaPeriod,0,SlowMaMode,SlowMaPrice,i);
   for(i=limit; i>=0; i--) sign[i] = iMAOnArray(macd,Bars,SignalMaPeriod,0,SignalMaMode,i);
   for(i=limit; i>=0; i--)
   { 
      if (Histo_Size<=0)Histo_Size=1;  
        osma[i] = (macd[i]-sign[i])*Histo_Size; 
        up1[i]  = EMPTY_VALUE;        
        dn1[i]  = EMPTY_VALUE;       
        trend[i]= trend[i+1];
          if (osma[i] > 0)  trend[i] =  1;
          if (osma[i] < 0)  trend[i] = -1;
          if (trend[i] == 1) up1[i] = osma[i];
          if (trend[i] ==-1) dn1[i] = osma[i];
   }     
   
   //
   //
   //
   //
   //
          
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");       
  }
return(0);
}       

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ColoredMACD ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ColoredMACD "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      
          
   
   